screen = {
		w = love.graphics.getWidth(),
		h = love.graphics.getHeight()
	}
	
	
--Game Settings
game_started = false
game_updateRate = 15
game_tick = 0
game_cellSize = 16

local color = {
		text = {255, 255, 255, 255}
	}

require "world"
require "slider"
	
function love.load()
	--Creating World
	m = world.new(256, 0, math.floor((screen.w - 256) / game_cellSize), math.floor(screen.h / game_cellSize), game_cellSize)
	
	local slider_x = 32
	local slider_y = 32
	local slider_offset = 32
	
	sliders = {
			slider.new("Update Rate", slider_x, slider_y, 256 - (slider_x * 2), 12, 15, 1, 30), -- update Rate 
			slider.new("Cell Size", slider_x, slider_y + slider_offset, 256 - (slider_x * 2), 12, game_cellSize, 4, 64), -- update Rate 
		}
end

function love.update(dt)
	--Updating world
	if game_started then
		game_tick = game_tick + dt
		if game_tick > 1 / game_updateRate then
			m:update()
			game_tick = 0
		end
	end
	
	if m.cellSize == game_cellSize then
	
	else
		reload()
	end
	
	
	--world manipulation
	local x, y = m:getWorldMouse()
	if not slider_pressed then
		if love.mouse.isDown("l") and love.mouse.getX() > m.x then
			m:setCellState(x, y, true)
		elseif love.mouse.isDown("r") and love.mouse.getX() > m.x then
			m:setCellState(x, y, false)
		end
	else -- slider shit
		for i,v in ipairs(sliders) do
			if v.isPressed then
				v:mouseDown()
			end
		end
	end

end

function love.draw()
	--Drawing world
	m:draw()
	
	
	--Drawing UI
	
	--Sliders
	for i,v in ipairs(sliders) do
		v:draw()
	end
	
	--Debug
	love.graphics.setColor(color.text)
	love.graphics.print("Update Rate: "..game_updateRate.."\nSimaltion Running: "..tostring(game_started).."\nFPS: "..love.timer.getFPS().."\nCells: "..m.w * m.h, 12, screen.h - 64)

end

function love.mousepressed(x, y, k)
	if k == "l" then
		for i,v in ipairs(sliders) do
			if v:mouseOver() then
				v:mousePressed()
			end
		end
	end
end

function love.mousereleased(x, y, k)
	if k == "l" then
		for i,v in ipairs(sliders) do
			v:mouseReleased()
		end
		game_updateRate = sliders[1].val.c
		game_cellSize = sliders[2].val.c
	end
end


function love.keypressed(key, unicode)
	if key == "escape" then
		love.event.push("quit")
	end
	
	if key == " " then
		game_started = not game_started
	elseif key == "s" then
		m:update()
	elseif key == "c" then
		for y=0, m.h-1 do
			for x=0, m.w-1 do
				m:setCellState(x, y, 0)
			end
		end
	elseif key == "i" then
		for y=0, m.h-1 do
			for x=0, m.w-1 do
				m:setCellState(x, y, not m.cell[y][x].state.c)
			end
		end
	end

end

function reload()
	m = world.new(256, 0, math.floor((screen.w - 256) / game_cellSize), math.floor(screen.h / game_cellSize), game_cellSize)
end

function love.keyreleased(key)
	
end